structure LiarCop :> COP =
struct

  (* Doesn't do anything but some (really uncreative) lying about the location
   * of the robber. *)

  structure T = Types
  structure S = Super
  structure G = Graph

  exception Impossible

  exception ST

  fun register () : S.register_msg * S.state = (("LiarCop", T.CopFoot), ST)

  fun world_skeleton (u, msg, s) : S.state = s

  fun randRange (lo, hi) =
      let val w = MLton.Random.rand ()
          open Word
          val word = Word.fromInt
          val int = Word.toInt
      in
          (int) (w mod (word hi - word lo + word 1) + word lo)
      end

  fun inform (u, _, s) : S.inform_msg * S.state = 
      let val nd = randRange (0, G.length (S.get_graph u))
          val cur_time = S.get_time u
          val t = 4
          val _ = Spew.spew ("Claiming the robber was on node " 
                             ^ (Int.toString nd) ^ " at time "
                             ^ (Int.toString t) ^ "!  Ha!")
      in
        ([(S.get_robber u, nd, T.Robber, t, 100)], s)
      end

  fun plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun vote (u, fp_msg, s) : S.vote_msg * S.state =
      (List.map (fn (bd, _) => bd) fp_msg, s)

  fun move (u, _, s) : S.clean_cop_move_msg * S.state
    = let val (nd, pt) = S.get_my_loc u
      in
        ({moves = [(nd, pt, S.get_name u)],
          offer = S.StraightArrow,
          accuse = nil}, s)
      end

  fun r_inform (u, _, s) : S.inform_msg * S.state = (nil, s)

  fun r_plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun r_vote (u, fp_msg, s) : S.vote_msg * S.state =
      (List.map (fn (bd, _) => bd) fp_msg, s)

  fun r_move (u, _, s) : S.dirty_cop_move_msg * S.state
    = let val (nd, pt) = S.get_my_loc u
      in
        ([(nd, pt, S.get_name u)], s)
      end

  fun r_results (u, _, s) : S.state = s

  fun dirtify (u, s) = ({inform=inform, plan=plan, vote=vote, move=r_move,
                         r_inform=r_inform, r_plan=r_plan, r_vote=r_vote,
                         r_results=r_results}, s)

  fun new _ = {register=register, world_skeleton=world_skeleton,
               dirtify=dirtify, inform=inform, plan=plan, vote=vote, move=move}

end
