structure NoOpCop :> COP =
struct

  structure T = Types
  structure S = Super
  structure G = Graph

  exception Impossible

  exception ST

  fun register () : S.register_msg * S.state = (("NoOpCop", T.CopFoot), ST)

  fun world_skeleton (u, msg, s) : S.state = s

  fun inform (u, _, s) : S.inform_msg * S.state = (nil, s)

  fun plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun vote (u, fp_msg, s) : S.vote_msg * S.state =
      (List.map (fn (bd, _) => bd) fp_msg, s)

  fun move (u, _, s) : S.clean_cop_move_msg * S.state
    = let val (nd, pt) = S.get_my_loc u
      in
        ({moves = [(nd, pt, S.get_name u)],
          offer = S.StraightArrow,
          accuse = nil}, s)
      end

  fun r_inform (u, _, s) : S.inform_msg * S.state = (nil, s)

  fun r_plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun r_vote (u, fp_msg, s) : S.vote_msg * S.state =
      (List.map (fn (bd, _) => bd) fp_msg, s)

  fun r_move (u, _, s) : S.dirty_cop_move_msg * S.state
    = let val (nd, pt) = S.get_my_loc u
      in
        ([(nd, pt, S.get_name u)], s)
      end

  fun r_results (u, _, s) : S.state = s

  fun dirtify (u, s) = ({inform=inform, plan=plan, vote=vote, move=r_move,
                         r_inform=r_inform, r_plan=r_plan, r_vote=r_vote,
                         r_results=r_results}, s)

  fun new _ = {register=register, world_skeleton=world_skeleton,
               dirtify=dirtify, inform=inform, plan=plan, vote=vote, move=move}

end
