structure ReturnToGoCop :> COP =
struct

  (* Always heads right for the robber start. *)

  structure T = Types
  structure S = Super
  structure G = Graph

  exception Impossible

  exception ST

  fun register () : S.register_msg * S.state =
      (("ReturnToGoCop", T.CopFoot), ST)

  fun world_skeleton (u, msg, s) : S.state = s

  fun inform (u, _, s) : S.inform_msg * S.state = (nil, s)

  fun plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun vote (u, _, s) : S.vote_msg * S.state = (S.get_cops_as_list u, s)

  fun move (u, _, s) : S.move_msg * S.state
    = let val g = S.get_graph u
          val (cur, _) = S.get_my_loc u
          val start = G.robberstart g
          val path = G.shortest_path g (G.Only T.CopFoot) cur start
          val nxt = case path 
                     of SOME ((nxt, _)::_) => nxt
                      | SOME nil => cur
                      | NONE => cur
      in
        ((nxt, T.CopFoot), s)
      end

  fun new _ = {register=register, world_skeleton=world_skeleton,
               inform=inform, plan=plan, vote=vote, move=move}

end
