structure NoOpRobber :> ROBBER = 
struct  

  structure T = Types
  structure S = Super
  structure G = Graph

  exception Impossible

  exception ST

  fun register () : S.register_msg * S.state = (("NoOpRobber", T.Robber), ST)

  fun world_skeleton (u, _, s) : S.state = s

  fun inform (u, _, s) : S.inform_msg * S.state = (nil, s)

  fun plan (u, _, s) : S.plan_msg * S.state = (nil, s)

  fun vote (u, fp_msg, s) : S.vote_msg * S.state = 
      (List.map (fn (bd, _) => bd) fp_msg, s)

  fun bribe (u, _, s) : S.bribe_msg * S.state = (S.NoBribe, s)

  fun move (u, _, s) : S.robber_move_msg * S.state
    = let val (nd, pt) = S.get_my_loc u
      in
        ({move = nd, result = S.BribeNone}, s)
      end

  fun new _ = {register=register, world_skeleton=world_skeleton, 
               inform=inform, plan=plan, vote=vote, bribe=bribe, move=move}
end
