structure Timer =
  struct
    open MLton
 
    val timer = Timer.startRealTimer ()
 
    fun reportTime () =
        print (Time.toString (Timer.checkRealTimer timer) ^ "\n")
 
    val r0 = ref 0
    val r1 = ref 0
    val r2 = ref 0
    
    fun handleAlarm () =
        ((* print "okay, giving my answer!\n"; *)
         if !r1 = !r2 then
             (*
             print (Int.toString (!r1) ^ " = " ^ Int.toString (!r2) ^ "\n");
             *)
             ()
         else
             print (Int.toString (!r1) ^ " <> " ^ Int.toString (!r2) ^ "\n");
         (* reportTime (); *)
         Posix.Process.exit 0w0)
          
    val () = Signal.setHandler (Itimer.signal Itimer.Real,
                                Signal.Handler.simple handleAlarm)
 
    val t = Itimer.set (Itimer.Real, { interval = Time.zeroTime,
                                       value = Time.fromReal 0.16 })
 
    (* val () = reportTime () *)
  
    fun inc (r as ref n) = r := n + 1
     
    val () = 
      while true do
        let in
          inc r0;
          (* MLton.Thread.atomically*)
          (fn () =>
            let 
               val x = ref 0
            in
               inc r1;
               while !x < 0(*100(*000*)*) do inc x;
               inc r2
            end)
            ()
        end
  end
