/*
 * Created on Jun 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cmu.cs.icfp2005.dfa;

import java.applet.Applet;
import java.applet.AudioClip;
import java.io.*;
import java.net.MalformedURLException;

/**
 * @author adam
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class DeadlyFutureCompiler {
    final private static AudioClip successSound;
    static {
        AudioClip a;
        try {
            a = Applet.newAudioClip(new File(DeadlyFutureArena.SOUND_FILE)
                    .toURL());
        } catch (MalformedURLException e) {
            e.printStackTrace();
            a = null;
        }
        successSound = a;
    }

    public static void main(String[] args) {
        DeadlyFutureCompiler dfc2001 = new DeadlyFutureCompiler();
        System.out.println("Entering Deadly Future Compiler 2001...");
        dfc2001.run();
    }

    private void run() {
        while (true) {
            try {
                // System.out.println("updating...");
                updateAndMaybeCompileBots();
            } catch (IOException e) {
                e.printStackTrace();
            }

            System.out.print("\r");
            try {
                Thread.sleep(200);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            System.out.print("Up to date, waiting for new bots");

            try {
                Thread.sleep(2000);
            } catch (InterruptedException e1) {
                e1.printStackTrace();
            }
        }
    }

    private void updateAndMaybeCompileBots() throws IOException {
        // File o = new File(OUTPUT);
        // PrintWriter p = new PrintWriter(new FileWriter(o));

        // int filesToCompile = 0;

        String cmd[] = { "cvs", "-q", "up" };
        final Process cvsP = Runtime.getRuntime().exec(cmd);
        new Thread(new ReReader(cvsP.getErrorStream())).start();
        new Thread() {
            public void run() {
                InputStream in = cvsP.getInputStream();
                BufferedReader b = new BufferedReader(new InputStreamReader(in));
                String line;
                try {
                    boolean printed = false;
                    while ((line = b.readLine()) != null) {
                        if (line.startsWith("P") || line.startsWith("U")) {
                            if (!printed) {
                                System.out.println();
                                printed = true;
                            }
                            System.out.println(line);
                        }
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }.start();
        try {
            cvsP.waitFor();
        } catch (InterruptedException e1) {
            e1.printStackTrace();
        }
        compile();
    }

    private void compile() throws IOException {
        // System.out.println("compiling...");

        String checkCmd[] = { "make", "-s", "-q" };

        Process query = Runtime.getRuntime().exec(checkCmd);
        try {
            query.waitFor();
        } catch (InterruptedException e1) {
            e1.printStackTrace();
        }
        if (query.exitValue() == 0) {
            return;
        }

        String makeCmd[] = { "make", "-s" };

        final Process p = Runtime.getRuntime().exec(makeCmd);
        new Thread() {
            public void run() {
                InputStream in = p.getInputStream();
                try {
                    int c;
                    while ((c = in.read()) != -1) {
                        System.out.write(c);
                    }
                    System.out.flush();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }.start();

        new Thread() {
            public void run() {
                InputStream in = p.getErrorStream();
                BufferedReader b = new BufferedReader(new InputStreamReader(in));
                try {
                    File f = File.createTempFile("dfa2000", "error", new File(
                            DeadlyFutureArena.RESULTS_DIR));
                    // System.out.println("temp file: " + f);
                    f.deleteOnExit();
                    FileWriter fw = new FileWriter(f);
                    PrintWriter out = new PrintWriter(fw);

                    String line;
                    while ((line = b.readLine()) != null) {
                        out.println(line);
                    }
                    out.close();
                    fw.close();
                    f.renameTo(new File(DeadlyFutureArena.ERROR_LOG_NAME));
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }.start();

        try {
            int result = p.waitFor();

            if (result != 0) {
                System.out.println("\nProblem compiling: result " + result);
            } else {
                successSound.play();
            }
        } catch (InterruptedException e) {
            e.printStackTrace();
        } finally {
            // System.out.println();
        }
    }

}