exception BotNotFound
exception TooManyArguments

fun printBots() =
    let in
        print "=COPS=\n";
        List.app (fn (x,_) => print (x ^ "\n")) cops;
        
        print "\n=ROBBERS=\n";
        List.app (fn (x,_) => print (x ^ "\n")) robbers
        
    end

fun main() = 
    let
        val args = Params.docommandline()
    in
        case args of
            [] => printBots()
          | [botName] => 
            let 
                val cop = ListUtil.Alist.find(op=) cops botName
            in
                case cop of
                    SOME c => ServerCoploop.run c
                  | NONE => 
                    let
                        val robber = ListUtil.Alist.find(op=) robbers botName
                    in
                        case robber of
                            SOME r => ServerRobberloop.run r
                          | NONE => 
                                let in
                                    print ("Bot: " ^ botName ^ " not found\n");
                                    raise BotNotFound
                                end
                    end
            end
          | _ => (print (Params.usage ()); raise TooManyArguments)
    end;

fun pspew s =
    let in
        Spew.spew s;
        print s
    end


(* go *)
val _ = main()
    handle (e as Graph.Graph s) => (pspew ("Graph error: " ^ s ^ "\n");
                                    raise e)
         | (e as Super.Super s) => (pspew ("Super error: " ^ s ^ "\n"); 
                                    raise e)
        (* more handlers here... *)
         | (e as Fail s) => (pspew ("general fail: " ^ s ^ "\n");
                             raise e)
         | (e as Parsing.Parse s) => (pspew ("parse error: " ^ s ^ "\n");
                              raise e)
         | e => 
        (pspew ("Other exception: " ^ exnName e ^ ":" ^ exnMessage e ^ "\n");
         app (fn s => pspew (s ^ "\n")) (MLton.Exn.history e);
         raise e)
                
