
(* this is a state transformer. It takes the state of the world
   (which is more than what is reported to the bots) and transforms
   it according to the action given. *)

(* XXX incomplete! *)

structure TransformByRobber =
struct

    open Transform

    (* enumerate legal actions (destinations). 
       This includes really dumb
       actions like walking onto cops. *)
    fun enumerate (GS{ skel, 
                       time, robber : exactrobber, ...}) =
        let in
            (* also self transition *)
            robber ::
            map #1
            (Graph.adjacent skel Graph.Forward (Graph.Only Types.Robber) robber)
        end

    fun transform (GS{ skel, time, loot, bank_vals, 
                       evidence, cops : RobberHeatTransform.cops_asheat, 
                       temp,
                       robber : exactrobber, transfers }) target =
        if time mod 2 <> 0
        then raise Transform "robber transforms even worlds."
        else 
            let 

                (* FIXME check that it's a legal move *)

                (* take money and schedule transfers,
                   if we landed on a bank spot *)
                val (bank_vals, loot, transfers) =
                    case List.partition
                        (fn (bn, _) => bn = target) bank_vals of
                        ([(thisn, thisv)], rest) =>
                            ((thisn, 0) :: rest,
                             loot + thisv,
                             (thisn, time + 8) :: transfers)
                      | _ => (bank_vals, loot, transfers)

                (* transfers happen afterward 
                   according to spec v6 *)

                (* there will be at most one that matches now
                   (by invt), so we just get the first wlog *)
                val nowtransfer =
                    List.find 
                    (fn (_, when) => when = time) transfers

                val bank_vals =
                    case nowtransfer of
                        NONE => bank_vals
                      | SOME (bank, _) =>
                            case List.partition 
                                (fn (bn, _) =>
                                 bn = bank) bank_vals of
                                ([(thisb, thisv)], otros) =>
                                    let 
                                        (* XXX assuming integer division *)
                                        fun go ((b, v)::t) l x = 
                                            let 
                                                val contrib = 
                                                    (v - thisv) div 6
                                            in
                                                go t ((b, v - contrib)::l) 
                                                       (x + contrib)
                                            end
                                          | go nil l x = (l, x)

                                        val (otros, new) = go otros nil 0
                                    in
                                        (thisb, thisv + new) :: otros
                                    end
                              | _ => raise Transform 
                           "bank not found or found multiply in transfer"
     

                (* old transfers go away *)
                val transfers = 
                    List.filter (fn (_, t) => t > time) transfers


                (* expire old evidence *)
                val evidence =
                    (* XXX boundary condition? *)
                    List.filter (fn (_, t) =>
                                 t < time + 24) evidence

                (* maybe leave new evidence *)
                val evidence =
                    if (time >= 8 andalso time mod 8 = 0)
                    then (robber, time) :: evidence
                    else evidence

                (* finally, move robber *)
                val robber = target

                (* this takes one turn *)
                val time = time + 1


                (* check heat *)
                fun heatat v i =
                    case Vector.sub(v, i) of
                        NONE => 0
                      | SOME (h, _) => h

                val temp = 
                    temp + heatat (#foot cops) robber +
                           heatat (#car  cops) robber
            in
                GS
                { skel = skel, 
                  time = time, 
                  loot = loot, 
                  temp = temp,
                  bank_vals = bank_vals, 
                  evidence = evidence, 
                  cops = cops, 
                  robber = robber,
                  transfers = transfers }
            end

    val transform = fn x => (transform x handle e => raise e)
    val enumerate = fn x => (enumerate x handle e => raise e)

end
