(* types common to many things *)
structure Types =
  struct

    datatype ptype = CopFoot | CopCar | Robber
    datatype node_tag = Hq | Bank | RobberStart | Ordinary
    datatype edge_tag = Car | Foot | Both

    fun edge_tag_cmp (Car, Foot) = LESS
      | edge_tag_cmp (Foot, Car) = GREATER
      | edge_tag_cmp _           = EQUAL

    type time = int
    type nid = int  (* node id *)
    type pid = string (* bot id *)
    type bid = string (* brain id *)
    type node = nid * node_tag * int * int
    type edge = nid * nid * edge_tag

    fun nttos Hq = "Hq"
      | nttos Bank = "Bank"
      | nttos RobberStart = "RobberStart"
      | nttos Ordinary = "Ordinary"

    fun ettos Foot = "Foot"
      | ettos Car = "Car"
      | ettos Both = "Both"

    fun pttos CopFoot = "CopFoot"
      | pttos CopCar = "CopCar"
      | pttos Robber = "Robber"

  end
